class IntegerRing() :

    """Cette classe contient tout ce dont nous avons besoin
    pour calculer un pgcd dans l'anneau des entiers"""
    
    value = 1

    def __init__(self, val) :
        """Construit un nouvel entier"""
        self.value = val

    def EuclideanDivision(self, B) :
        """Calcule la division euclidienne de self par
        B et retourne le quotient et le reste."""
        return IntegerRing(self.value // B.value), ##
               IntegerRing(self.value % B.value)

    def getAdditionNeutral(self) :
        """Retourne l'element neutre de l'addition."""
        return IntegerRing(0)

    def getMultiplicationNeutral(self) :
        """Retourne l'element neutre de la multiplication."""
        return IntegerRing(1)

    def isNull(self) :
        """Retourne True si self est egal a l'element
        neutre de l'addition"""
        if self.value == 0 :
            return True
        else :
            return False

    def simplify_pgcd(self) :
        """Dans le cas des entiers, l'algorithme d'Euclide
        donne directement le pgcd. Cette fonction n'a rien
        d'autre a faire que de renvoyer sa donnee d'entree."""
        return self

    def simplify_pgcd_and_coeffs(self, coefA, coefB) :
        """Dans le cas des entiers, l'algorithme d'Euclide
        donne directement le pgcd. Cette fonction n'a rien
        d'autre a faire que de renvoyer ses donnees en entrees."""
        return self, coefA, coefB
        
    def __add__(self, B) :
        """Additionne deux entiers"""
        return IntegerRing(self.value + B.value)

    def __sub__(self, B) :
        """Soustrait B a self"""
        return IntegerRing(self.value - B.value)

    def __mul__(self, B) :
        """Multiplie deux entiers"""
        return IntegerRing(self.value * B.value)

