
class ZnZRing() :

    """Cette classe contient tout ce dont nous avons besoin 
    pour calculer un pgcd dans l'anneau Z/nZ"""
    def __init__(self, val, n) :
        """Construit un nouvel entier"""
        self.value = val % n
        self.n = n

    def EuclideanDivision(self, B) :
        """Calcule la division euclidienne de self par B
        et retourne le quotient et le reste."""
        return ZnZRing(self.value // B.value, self.n), ##
               ZnZRing(self.value % B.value, self.n)

    def getAdditionNeutral(self) :
        """Retourne l'element neutre de l'addition."""
        return ZnZRing(0, self.n)

    def getMultiplicationNeutral(self) :
        """Retourne l'element neutre de la multiplication."""
        return ZnZRing(1, self.n)

    def isNull(self) :
        """Retourne True si self est egal a l'element 
        neutre de l'addition"""
        if self.value == 0 :
            return True
        else :
            return False

    def simplify_pgcd(self) :
        """Dans le cas des entiers, l'algorithme d'Euclide
        donne directement le pgcd. Cette fonction n'a rien
        d'autre a faire que de renvoyer sa donnee d'entree."""
        return ZnZRing(self.value, self.n)

    def simplify_pgcd_and_coeffs(self, coefA, coefB) :
        """Dans le cas des entiers, l'algorithme d'Euclide
        donne directement le pgcd. Cette fonction n'a rien
        d'autre a faire que de renvoyer sa donnee d'entree."""
        return ZnZRing(self.value, self.n), ##
               ZnZRing(coefA.value, coefA.n), ##
               ZnZRing(coefB.value, coefB.n)
        
    def __add__(self, B) :
        """Additionne deux entiers"""
        return ZnZRing(self.value + B.value, self.n)

    def __sub__(self, B) :
        """Soustrait B a self"""
        return ZnZRing(self.value - B.value, self.n)

    def __mul__(self, B) :
        """Multiplie deux entiers"""
        return ZnZRing(self.value * B.value, self.n)

